﻿----------------------------------------------------------------------------------------------------
-- DroodFocus 4.0.0 - alert
-- Meranannon - Discordia - Vol'jin (EU)
-- rev 1
----------------------------------------------------------------------------------------------------

local DF = DF_namespace

local state=0
local scale=1

local frame=nil
local frameTexture=nil
local overlay=nil
local overlayTexture=nil
local frametext = nil
local frametext_overlay = nil	

local frequency =1/60
local tempo=0

-- initialisation frames
function DF:init_alert_frame()
	
	if not frame then
		
		-- cadre principal
--		frame = CreateFrame("FRAME","DF_ALERT_FRAME",DF.anchor[1].frame)
		frame = CreateFrame("FRAME","DF_ALERT_FRAME",UIParent)

		frame:SetScript("OnMouseDown",function(self,button)
			if button=="LeftButton" then
  			frame:StartMoving()
  		elseif button=="RightButton" then
  			DF:options_show("DFalert",frame)
  		end
  	end)
		frame:SetScript("OnMouseUp",function(self,button)
			if button=="LeftButton" then
	  		frame:StopMovingOrSizing()
--		  		anchorx=DF.anchor[1].frame:GetLeft()
--		  		anchory=DF.anchor[1].frame:GetTop()		  		
--		  		DF_config.alert.positionx = self:GetLeft()-anchorx
--		  		DF_config.alert.positiony = self:GetTop()-anchory
		  		DF_config.alert.positionx = DF:alignToGridX(self:GetLeft())
		  		DF_config.alert.positiony = DF:alignToGridY(self:GetBottom())
		  		frame:ClearAllPoints()
		  		frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", DF_config.alert.positionx, DF_config.alert.positiony)
					DF.environnement["DFalertleft"]:Hide()
					DF.environnement["DFalerttop"]:Hide()
					DF.environnement["DFalertleft"]:Show()
					DF.environnement["DFalerttop"]:Show()			
		  end
		end)	
		frame:SetScript("OnEnter",function(self,button)
			if DF.configmode then
				GameTooltip:SetOwner(UIParent, "ANCHOR_TOPLEFT ",16,-16)
				GameTooltip:ClearLines()
				GameTooltip:AddLine("DROODFOCUS ALERT",1,1,0,nil)
				GameTooltip:AddLine(DF.locale["leftMB"],1,1,1,nil)
				GameTooltip:AddLine(DF.locale["rightMB"],1,1,1,nil)
				GameTooltip:Show()		
			end		
		end)		
		frame:SetScript("OnLeave",function(self,button)
			if DF.configmode then GameTooltip:Hide() end
		end)		
				
		-- cadre pour la texture
		overlay = CreateFrame("FRAME","DF_ALERT_OVERLAY",frame)
		
		-- la texture
		overlayTexture = overlay:CreateTexture("DF_ALERT_OVERLAY_TEXTURE","BACKGROUND")
		frameTexture = frame:CreateTexture("DF_ALERT_FRAME_TEXTURE","BACKGROUND")

		-- le text
		frametext_overlay = CreateFrame("FRAME","DF_ALERT_FRAMETEXT_OVERLAY",frame)
		frametext_text = frametext_overlay:CreateFontString("DF_ALERT_FRAMETEXT_TEXT","ARTWORK")		

		frame:EnableMouse(false)	
			
	end

	local level = DF_config.alert.level*10

	-- paramétres cadre principal
	frame:SetMovable(true)
	
	frame:SetWidth(64)
	frame:SetHeight(64)
	frame:ClearAllPoints()
--	frame:SetPoint("TOPLEFT", DF.anchor[1].frame, "TOPLEFT", DF_config.alert.positionx, DF_config.alert.positiony)
	frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", DF_config.alert.positionx, DF_config.alert.positiony)
	frame:SetFrameLevel(level)

	-- paramétres texture
	frameTexture:SetTexCoord(0, 1, 0, 1)
	frameTexture:ClearAllPoints()
	frameTexture:SetAllPoints(frame)
	
	frameTexture:SetTexture(1,1,1,0)

	-- paramétres cadre texture
	overlay:SetMovable(false)
	overlay:EnableMouse(false)		
	overlay:SetWidth(DF_config.alert.width)
	overlay:SetHeight(DF_config.alert.height)
	overlay:SetPoint("CENTER", frame, "CENTER", 0, 0)
	overlay:SetFrameLevel(level+1)
	
	-- paramétres texture
	overlayTexture:SetTexCoord(0, 1, 0, 1)
	overlayTexture:SetWidth(128)
	overlayTexture:SetHeight(128)
	overlayTexture:SetBlendMode(DF_config.alert.mode)
	overlayTexture:ClearAllPoints()
	overlayTexture:SetAllPoints(overlay)
	overlayTexture:SetTexture(DF_config.alert.texture1)
	
	-- place la texture dans le cadre
	overlay.texture = overlayTexture

	-- parametre texte
	frametext_overlay:SetWidth(256)
	frametext_overlay:SetHeight(32)
	frametext_overlay:ClearAllPoints()
	frametext_overlay:SetPoint("CENTER", frame, "CENTER", 0, 0)
	frametext_overlay:SetFrameLevel(level+2)	

	DF:MySetFont(frametext_text,DF_config.alert.fontPath,DF_config.alert.fontSize,"OUTLINE")
	frametext_text:SetWidth(256)
	frametext_text:SetHeight(32)	
	frametext_text:SetJustifyH('CENTER')
	frametext_text:SetJustifyV('MIDDLE')	
	frametext_text:SetShadowColor(0, 0, 0, 0.75)
	frametext_text:SetShadowOffset(0.5, -0.5)
	frametext_text:SetTextColor(DF_config.alert.textColor.r, DF_config.alert.textColor.v, DF_config.alert.textColor.b, DF_config.alert.textColor.a)
	frametext_text:ClearAllPoints()
	frametext_text:SetPoint("CENTER", frametext_overlay,"CENTER", DF_config.alert.textOffsetX,DF_config.alert.textOffsetY)
	frametext_text:SetText("")
	
	overlay:Hide()
		
end

-- gestion de l'animation
function DF:alert_update(elapsed)

	if not DF_config.alert.enable then
		overlay:Hide();		
		return
	end

	tempo=tempo+elapsed
	if tempo<frequency then return end
	tempo=0		
		
	if DF.configmode then
		frameTexture:SetTexture(1,1,1,0.25)
	else
		frameTexture:SetTexture(1,1,1,0)
	end

	if state == 1 then
	
		if scale>1 then
			scale  = scale  - elapsed
		else
			scale  = scale  - 0.15
		end
	
		local tempScale=scale
	
		if	tempScale>1 then tempScale=1 end			
		if	tempScale<0.1 then
			tempScale=0.1
			state=0
			frametext_text:SetText("")
		end
					
		overlay:SetScale(tempScale);
		overlay:Show();		
		
	elseif state==2 then
		
		scale  = scale  - 0.025
		
		overlay:SetScale(scale);
		overlay:Show();		

		if	scale<1 then
			
			scale=DF_config.alert.persistence
			state=1
			
		end
			
	else
		
		overlay:Hide()
		frametext_text:SetText("")	
		
	end

	if DF.configmode then
		overlayTexture:SetTexture("Interface\\AddOns\\DroodFocus\\datas\\alertBehind.tga")
		overlay:SetScale(1)
		if DF_config.alert.showText then
			frametext_text:SetText("INFORMATIONS")
		end
		overlay:Show()
	end
	
end

function DF:alert_activate(aType,force,letexte)
	if not DF_config.alert.enable then
		return
	end	
	
	if state==0 or force then
		
		if aType=="1" then
			overlayTexture:SetTexture(DF_config.alert.texture1)
			frametext_text:SetText("")
		elseif aType=="2" then
			overlayTexture:SetTexture(DF_config.alert.texture2)
			frametext_text:SetText("")
		elseif aType=="3" then
			overlayTexture:SetTexture(DF_config.alert.texture3)
			frametext_text:SetText("")
		else
			overlayTexture:SetTexture(aType)
			if letexte and DF_config.alert.showText then
				frametext_text:SetText(letexte)
			end
		end
		
		state=2
		scale=1.5
		
	end
	
end

-- enable/disable déplacement du cadre avec la souris
function DF:alert_toogle_lock(flag)
	
	frame:EnableMouse(flag)
	
end

function DF:alert_reinit()
	
	DF:init_alert_frame()
	DF:alert_activate("1",true)
	
end