----------------------------------------------------------------------------------------------------
-- DroodFocus 4.2.7 - Lua
-- Meranannon - Insane - Vol'jin (EU)
-- rev 1
----------------------------------------------------------------------------------------------------
local DF = DF_namespace
local DFLuaCurrentNum=0

local defaultText="-- Enter your code here.\n\n"
--.."-- Arguments passed to the function :\n"
--.."--  arg1 : Spell type.\n"
--.."--  arg2 : Spell ID.\n"
--.."--  arg3 : Spell text.\n"
--.."--  arg4 : Spell start time.\n"
--.."--  arg5 : Spell end time.\n"
--.."--  arg6 : Spell time left.\n"
--.."--  arg7 : Spell duration.\n"
--.."--  arg8 : Spell stack.\n"
--.."--  arg9 : Spell cooldown.\n\n"
.."-- Your function return :\n"
.."--  true: activate object."
.."--  false: does not activate object.\n"
.."--  nil (by default if nothing returned): does not activate object.\n"

--
-- cration fentre saisie
--
DF.LuaWindow = CreateFrame("FRAME","DroodFocusLuaWindow",UIParent,"OptionsBoxTemplate")
DF.LuaWindow:SetMovable(true)
DF.LuaWindow:EnableMouse(true)
DF.LuaWindow:SetBackdrop({ bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark.blp", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
DF.LuaWindow:SetFrameStrata("DIALOG");
DF.LuaWindow:SetBackdropColor(0,0,0,1);
DF.LuaWindow:SetWidth(480)
DF.LuaWindow:SetHeight(300)
DF.LuaWindow:ClearAllPoints()
DF.LuaWindow:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
DF.LuaWindow:SetScript("OnMouseDown",function(self)
	DF.LuaWindow:StartMoving()
end)
DF.LuaWindow:SetScript("OnMouseUp",function(self)
	DF.LuaWindow:StopMovingOrSizing()
end)	
DF.LuaWindow:SetFrameLevel(125)

temp = CreateFrame("FRAME","DroodFocusLuaWindowbar",DF.LuaWindow);
temp:SetMovable(false)
temp:EnableMouse(true)
t=temp:CreateTexture(nil);
temp.texture=t;
temp:SetHeight(22)
temp:SetWidth(480-4)
temp:SetPoint("TOPLEFT", DF.LuaWindow, "TOPLEFT", 2, -2)
temp.texture:SetAllPoints(temp)
temp.texture:SetTexture(90/255,106/255,80/255,0.85);
temp.text = temp:CreateFontString(nil, "OVERLAY", "GameFontNormal")
temp.text:SetText("DroodFocus - Lua code editor.")
temp.text:SetPoint("LEFT", temp, "LEFT", 6, 0);	
temp:SetScript("OnMouseDown",function(self)
	DF.LuaWindow:StartMoving()
end)
temp:SetScript("OnMouseUp",function(self)
	DF.LuaWindow:StopMovingOrSizing()
end)	
temp:SetFrameLevel(126)

local button = CreateFrame("Button", "DroodFocusLuaWindowClose", DF.LuaWindow, "GameMenuButtonTemplate")
button:SetText("X")
button:SetWidth(20)
button:SetHeight(20)
button:SetPoint("TOPRIGHT", DF.LuaWindow, "TOPRIGHT", -4, -3)
button:SetScript("OnClick", function(self)
	DF.LuaWindow:Hide()
end)
button:SetFrameLevel(127)

local scroll = CreateFrame("ScrollFrame", "DroodFocusLuaWindowScroll", DF.LuaWindow, "UIPanelScrollFrameTemplate")
scroll:SetPoint("TOPLEFT", DF.LuaWindow, 6, -26)
scroll:SetPoint("BOTTOMRIGHT", DF.LuaWindow, -27, 25)
local textArea = CreateFrame("EditBox", "DroodFocusLuaWindowScrollText", scroll)
textArea:SetAutoFocus(false)
textArea:SetMultiLine(true)
textArea:SetFontObject(GameFontHighlightSmall)
textArea:SetMaxLetters(99999)
textArea:EnableMouse(true)
textArea:SetScript("OnEscapePressed", textArea.ClearFocus)
textArea:SetWidth(450)
scroll:SetScrollChild(textArea)
textArea:SetFrameLevel(127)
button:SetScript("OnShow", function(self)
	if DFLuaCurrentNum~=0 then
		texte=DF_config.spells[DFLuaCurrentNum].luaCode
		textArea:SetText(texte)
	else
		textArea:SetText("")		
	end	
end)

local button1 = CreateFrame("Button", "DroodFocusLuaWindowValider", DF.LuaWindow, "GameMenuButtonTemplate")
button1:SetText("Valider")
button1:SetWidth(60)
button1:SetHeight(20)
button1:SetPoint("BOTTOMRIGHT", DF.LuaWindow, "BOTTOMRIGHT", -4, 4)
button1:SetScript("OnClick", function(self)
	if DFLuaCurrentNum~=0 then

		textArea:ClearFocus()
		local text = string.trim(textArea:GetText())
		local result,err = DF:luaCode_run(text)
		if result then
			DF_config.spells[DFLuaCurrentNum].luaCode=text
			DF.LuaWindow:Hide()
			DF:spells_list_reinit()	
		end
	
	end
	textArea:ClearFocus()

end)
button1:SetFrameLevel(127)

local button3 = CreateFrame("Button", "DroodFocusLuaWindowClear", DF.LuaWindow, "GameMenuButtonTemplate")
button3:SetText("Effacer")
button3:SetWidth(60)
button3:SetHeight(20)
button3:SetPoint("BOTTOMLEFT", DF.LuaWindow, "BOTTOMLEFT", 4, 4)
button3:SetScript("OnClick", function(self)
	textArea:ClearFocus()
	textArea:SetText("")		
	textArea:SetFocus()
end)
button3:SetFrameLevel(127)

local button4 = CreateFrame("Button", "DroodFocusLuaWindowTest", DF.LuaWindow, "GameMenuButtonTemplate")
button4:SetText("Tester")
button4:SetWidth(60)
button4:SetHeight(20)
button4:SetPoint("BOTTOMLEFT", button3, "BOTTOMRIGHT", 1, 0)
button4:SetScript("OnClick", function(self)
	textArea:ClearFocus()
	DEFAULT_CHAT_FRAME:AddMessage("Testing your code...");
	local text = string.trim(textArea:GetText())
	local result,err = DF:luaCode_run(text)
	if result then
		DEFAULT_CHAT_FRAME:AddMessage("Test ok.")
	end
end)
button4:SetFrameLevel(127)
DF.LuaWindow:Hide()

function DF:luaCode_showWindow()
	DF.LuaWindow:SetFrameLevel(125)
	DF.LuaWindow:Show()
end

function DF:luaCode_updateWindow(newval)
	DFLuaCurrentNum=newval
	texte=DF_config.spells[DFLuaCurrentNum].luaCode
	textArea:SetText(texte)	
end

function DF:luaCode_setNum(value)
	DFLuaCurrentNum=value
end

function DF:luaCode_run(luaBlock)

	local func,err = assert(loadstring(luaBlock, "DroodFocusLuaCodeTest"))
	
	if not func then
		return false,err
	else
		return true,nil
	end
	
end

function DF:luaCode_addRefs(sName,pointeur)
	
	DFREFS[sName]=pointeur

end

function DF:luaCode_showRefs()
	for index, value in pairs(DFREFS) do
		DEFAULT_CHAT_FRAME:AddMessage(tostring(index))
	end
end
